<svelte:window on:keydown="onKeyDown(event)"
               on:resize="onResize()"
               on:beforeinstallprompt="set({beforeInstallPrompt: event})"/>

<svelte:head>
  <title>
    {$guild ? $guild.name + ": " : ""}{$guild ? ($channel ? "#" : "") : ($channel ? "@" : "")}{$channel ? $channel.name + " — "
    : ""}Harmony
  </title>
  <meta name="og:title" content={config.siteName}>
  <meta name="og:type" content="website">
  <meta name="og:url" content={config.canonicalUrl}>
  <meta name="og:image" content={config.icon}>
  <meta name="og:site_name" content={config.siteName}>
  <meta name="og:description" content={config.description}>
  <meta name="og:determiner" content="a">
  <meta name="og:locale" content="en_US">
  <meta name="og:locale:alternate" content="en_GB">
</svelte:head>

<div class="app"
     on:dragover="refs.messageArea.dragOver(event)"
     on:dragleave="refs.messageArea.dragLeave(event)"
     on:drop|preventDefault="refs.messageArea.onDrop(event, files)"
     on:click="globalClick({$contextMenu})">
  <div class="modal-holder">
    {#if $modal}
    <svelte:component
      this={$modal.component}
      on:modalEvent="executeFunction($modal.listener, event)"
      modalContext={$modal.options} /> {:elseif beforeInstallPrompt}
    <AdvancedModal>
      <h2>Install PWA</h2>
      <p>You can install Harmonica as an app on your device.</p>
      <Button color="danger" on:click="set({beforeInstallPrompt:null})" text="No thanks!"/>
      <Button color="primary" on:click="installPrompt(beforeInstallPrompt)" text="Install" />
    </AdvancedModal>
    {/if}
  </div>
  <div class="tooltip-holder">
    {#if $tooltip && !$contextMenu}
    <TooltipPoint value={$tooltip.value} parent={$tooltip.ref} /> {/if}
  </div>
  <div class="context-hold">
    <ContextPoint
      choices={$contextMenu && $contextMenu.choices}
      ev={$contextMenu && $contextMenu.event} />
  </div>

  {#if $token}
  <div class="app-flex">
    {#if $guild}
    <LocalStyle id={$guild.id} />
    {/if}
    <UserStyle style={$userStyle} />
    <div class="left-drawer">
      <Drawer position="left" bind:opened="navigationOpened">
        <div class="guilds">
          {#each $guilds as guild (guild.id)}
          <Guild id={guild.id} name={guild.name} icon={guild.icon}></Guild> {/each}
          <Guild id={null}
                 name="Create a Guild"
                 outline={true}
                 on:click="createGuild()">
            +
          </Guild>
        </div>
        <div class="local-style-scope channel-scope">
          <div class="channels">
            {#if $guild}
            <GuildHeader>{$guild.name}</GuildHeader>
            <div class="channel-list">
              <CreateChannelButton {$guildId} />
              {#each channels as channel (channel.id)}
              <ChannelSelection id={channel.id}
                                name={channel.name}
                                type={channel.type}
                                selected={channel.id == $channelId}
                                {channel} />
              {/each}
            </div>
            {:else}
            <!-- I don't like doing this but oh well... -->
            <div class="channel-list-placeholder" />
            <!-- TODO: Figure out what goes here...? -->
            {/if}
            <div class="own-preview">
              <OwnUserPreview username={$username} avatar={$avatar} discriminator={$discriminator} />
            </div>
          </div>
        </div>
      </Drawer>
    </div>

    <div class="local-style-scope message-scope">
      <div class="messages">
        {#if $channel}
        {#if $channel.media}
        <CallView channelId={$channel.id} />
        {:else}
        <MessageArea ref:messageArea channelId={$channel.id} />
        {/if}
        {:else}
        hi seems like you don't have a channel selected or something
        {/if}
      </div>
      {#if $guild && $channel}
      <div class="right-drawer">
        <Drawer position="right">
          <div class="member-list">
            <MemberList guildId={$guild.id} channelId={$channel.id} />
          </div>
        </Drawer>
      </div>
      {/if}
    </div>

    <div class="shade"
       class:shade-open="$shade && $shade > 0"
       data-egg={`background-color:rgba(0, 0, 0, ${Math.floor($shade * 100)});`}
       style={`background-color:rgba(0, 0, 0, ${$shade * 0.5});`} />

  </div>
  {:else}
  <AuthPage /> {/if}
</div>

<script>
  import Guild from "./Guild.svelte";
  import ChannelSelection from "./ChannelSelection.svelte";
  import MessageArea from "./MessageArea.svelte";
  import CreateGuildModal from "./modals/CreateGuildModal.svelte";
  import TooltipPoint from "./TooltipPoint.svelte";
  import CreateChannelButton from "./CreateChannelButton.svelte";
  import GuildHeader from "./GuildHeader.svelte";
  import AuthPage from "./AuthPage.svelte";
  import ContextPoint from "./ContextPoint.svelte";
  import OwnUserPreview from "./OwnUserPreview.svelte";
  import LocalStyle from "./LocalStyle.svelte";
  import RealTimeClient from "../js/RealTimeClient";
  import Config from "../config";
  import Button from "./forms/Button.svelte";
  import device from "../js/device";
  import ChannelStore from "../stores/ChannelStore";

  export default {
    onstate({current, changed}) {
      if (changed.$guildId && current.$guildId) {
        this.set({
          channels: []
        });
        ChannelStore.subscribeComponent(
          current.$guildId,
          this,
          this.onGuildChannelsChange,
          "g"
        );
      }
    },
    oncreate() {
      window.app = this;
      if (location.hash.startsWith("#/invites/")) {
        // 10 = length of #/invites/
        const inviteCode = location.hash.substring(10);
        RealTimeClient.once("ready", () => {
          this.store.set({
            modal: {
              component: CreateGuildModal,
              options: {
                inviteCode
              }
            }
          });
        });
      }
    },
    data() {
      return {
        config: Config
      };
    },
    components: {
      CallView: "./CallView.svelte",
      LocalStyle,
      Guild,
      ChannelSelection,
      MessageArea,
      TooltipPoint,
      CreateChannelButton,
      GuildHeader,
      AuthPage,
      OwnUserPreview,
      ContextPoint,
      MemberList: "./MemberList.svelte",
      Drawer: "./Drawer.svelte",
      Button,
      AdvancedModal: "./modals/AdvancedModal.svelte",
      UserStyle: "./UserStyle.svelte"
    },
    methods: {
      onGuildChannelsChange() {
        const channels = ChannelStore.getItems(this.store.get().guildId);
        this.set({channels});
      },
      executeFunction(fn, ...args) {
        fn.apply(null, args);
      },
      onResize() {
        device.lastWidth = document.documentElement.clientWidth;
        console.log("rsz", device.lastWidth);
        this.store.set({lastWidth: device.lastWidth});
      },
      installPrompt(event) {
        event.prompt();
        this.set({beforeInstallPrompt: null});
      },
      globalClick({$contextMenu}) {
        console.log("GOT CLICK!", $contextMenu);
        if ($contextMenu) {
          if ($contextMenu.onClose) $contextMenu.onClose();
          this.store.set({contextMenu: undefined});
        }
      },
      createGuild() {
        console.log("opening guild modal");
        this.store.set({
          modal: {
            component: CreateGuildModal
          }
        });
      },
      onKeyDown(event) {
        const code = event.which || event.keyCode;
        console.log("Owo", code, event.key, event);
        const up = 38;
        const down = 40;
        const guildMove = 221; // 9;
        let prevent = true;
        if (event.altKey && (code == down || code == up)) {
          const got = this.store.get();
          if (!got.channel) return;
          console.log("nice!");
          const diff = code == down ? 1 : -1;
          const channel =
            got.channels[got.channelIds.indexOf(got.channel.id) + diff];
          console.log("joining into...", channel);
          if (channel) this.store.setChannel(channel.id);
        } else if (event.ctrlKey && code == guildMove) {
          console.log("bap");
          const got = this.store.get();
          const guildIndex = got.guildIds.indexOf(got.guildId);
          const diff = event.shiftKey ? -1 : 1;
          const guildId = got.guildIds[guildIndex + diff];
          console.log(guildIndex, guildIndex + diff);
          if (guildId) this.store.setChannel(guildId);
        } else prevent = false;
        if (prevent) {
          console.log("preventing", code);
          event.preventDefault();
        }
      }
    }
  };
</script>

<style>
  .app-flex {
    max-width: 100vw;
    max-height: 100vh;
    display: flex;
    flex-wrap: nowrap;
  }
  .guilds,
  .channels,
  .messages,
  .members {
    display: inline-block;
    max-height: 100vh;
    min-height: 100vh;
  }
  .guilds,
  .members {
    overflow-y: auto;
    height: 100vh;
  }

  .channels {
    height: 100vh;
  }

  .channel-list-placeholder {
    height: 100%;
  }

  .channel-list {
    height: 100%;
    overflow-y: auto;
    /* 3em: guild header */
    /* 6px: ????????????? */
    /* 4em: OwnUserPreview */
    /* 5px: ????????????? */
    /* 1em: ????????????? */
  }

  .messages {
    background-color: #202224;
    display: flex;
    flex-wrap: nowrap;
    flex-direction: column;
    max-height: 100vh;
    flex: 1 1 auto;
    width: 60vw;
    max-width: 100vw;
  }

  .navigation {
    width: calc(15vw + 73px);
  }

  .member-list {
    width: calc(15vw - 16px);
    overflow: auto;
    max-height: 100vh;
  }

  .channels {
    display: flex;
    flex-direction: column;
    width: 15vw;
  }

  .own-preview {
    flex: 0;
  }
  
  .local-style-scope.message-scope {
    display: flex;
    flex: 1 1 auto;
  }

  @media (max-width: 700px) {
    :global(body), :global(html) {
      overflow-x: hidden;
    }
    .messages {
      min-width: 100vw;
      width: 100vw;
    }
    .member-list {
      position: absolute;
      width: 70vw;
    }
    .left-drawer {
      position: absolute;
      width: 70vw;
      transform: translateX(-70vw);
    }
    .channel-scope {
      flex: 1 1 auto;
    }
    .channels {
      width: 100%;
    }
    .left-drawer, .right-drawer {
      z-index: 50;
    }
  }
  .shade {
    display: none;
  }
  .shade.shade-open {
    display: block;
    top: 0;
    bottom: 0;
    left: 0;
    right: 0;
    position: absolute;
    height: 100vh;
    width: 100vw;
    z-index: 40;
  }
  .channel-scope {
    background: #1a1a1b;
  }
</style>
